Subject: Re: [PATCH 00/14] Add submodule test harness

From: Torsten Bögershausen <[email-masked]>
Date: Thu, 03 Jul 2014 07:56:58 +0200

On 07/02/2014 09:57 PM, Jens Lehmann wrote:
> Am 02.07.2014 16:54, schrieb Torsten Bögershausen:
>> (Not sure if this is the right thread)
>> (I haven't checked if this is fixed in your latest version)
> Yes, this is the right thread and no, it isn't fixed yet.
>
>> On what I have on pu 7a0da7902cbbc9a876b90c9, Tue Jul 1 14:51:53 2014 -0700
>>
>> Many submodule tests are broken.
>> One problem is here:
>>
>> lib-submodule-update.sh:264: possible problem: echo -n is not portable (please use printf):                     echo -n >sub1 &&
>> lib-submodule-update.sh:507: possible problem: echo -n is not portable (please use printf):                     echo -n >sub1 &&
>>
>> You can remove the "empty" "echo -n" to create an empty file:
>>> sub1 &&
> Thanks for spotting and diagnosing this. Running "make lint" in the
> test directory only feeds the tests to check-non-portable-shell.pl,
> but not the *lib*.sh helper scripts, which made me miss this one.
>
> The following diff should fix it for you. Am I understanding you
> correctly that you are experiencing other failures too? I see no
> other incompatibilities when running ./check-non-portable-shell.pl
> on all the shell scripts in the repo.
The longer story is that I run the test suite once a week or so.
Most often under Mac OS, sometimes cygwin or Linux.
Whenever there is a breakage under Mac OS which I can not
debug within some minutes, I run it under Linux to see if there
is the same breakage.

The ./check-non-portable-shell.pl can sometimes give an indication
why some test fail.
You can run it from command line:
  ./check-non-portable-shell.pl *.sh
and it will find the "echo -n" which I reported.
On the longer run it could probably check all *.sh files,
not only the ones under t/
I do not have the time to test the snipped patch below, but I can check pu
when the next round of your patch is in and give you some more info.